# grdtrend

Fit trend surface to grids and compute residuals

## Synopsis

gmt grdtrend ingrid -N n_model[+r][+x|y] [ -D diff.nc ] [ -R region ] [ -T trend.nc ] [ -V[level] ] [ -W weight.nc ] [ --PAR=value ]

Note: No space is allowed between the option flag and the associated arguments.

## Description

grdtrend reads a 2-D grid file and fits a low-order polynomial trend to these data by [optionally weighted] least-squares. The trend surface is defined by:

\[m_1 + m_2x + m_3y + m_4xy + m_5x^2 + m_6y^2 + m_7x^3 + m_8x^2y + m_9xy^2 + m_{10}y^3.\]

The user must specify -N n_model, the number of model parameters to use; thus, -N 3 fits a bilinear trend, -N 6 a quadratic surface, and so on. Optionally, append +r to the -N option to perform a robust fit. In this case, the program will iteratively reweight the data based on a robust scale estimate, in order to converge to a solution insensitive to outliers. This may be handy when separating a “regional” field from a “residual” which should have non-zero mean, such as a local mountain on a regional surface. Optionally, you may choose to fit a trend that varies only along the x or y axis, in which case you select an n_model from 1 (constant) to 4 (cubic).

If data file has values set to NaN, these will be ignored during fitting; if output files are written, these will also have NaN in the same locations.

## Required Arguments

ingrid[=ID|?varname][+b band][+d divisor][+n invalid][+o offset][+s scale]

> Optionally, append =ID for reading a specific file format [Default is =nf] or ?varname for a specific netCDF variable [Default is the first 2-D grid found by GMT]. The following modifiers are supported:

> > - +b - Select a band [Default is 0].

> > - +d - Divide data values by the given divisor [Default is 1].

> > - +n - Replace data values matching invalid with NaN.

> > - +o - Offset data values by the given offset [Default is 0].

> > - +s - Scale data values by the given scale [Default is 1].

> Note: Any offset is added after any scaling.

-N n_model[+r][+x|y]

  n_model sets the ID of the highest model parameters to fit. Append +r for robust fit. As an option, append either +x or +y to only fit a model that depends on x or y terms, respectively. This means we either fit \(m_1 + m_2x + m_3x^2 + m_4x^3\) or \(m_1 + m_2y + m_3y^2 + m_4y^3\). Note that n_model may only be 1-4 for the one-dimensional fits but may be 1-10 for the two-dimensional surface fits.

## Optional Arguments

-D diff.nc

  Write the difference (input data - trend) to the file diff.nc.

-R xmin/xmax/ymin/ymax[+r][+u unit]

  Specify the region of interest. Using the -R option will select a subsection of the input grid. If this subsection exceeds the boundaries of the grid, only the common region will be extracted. (See full description) (See cookbook information).

-T trend.nc

  Write the fitted trend to the file trend.nc.

-V[level]

  Select verbosity level [w]. (See full description) (See cookbook information).

-W weight.nc[+s]

  If weight.nc exists, it will be read and used to solve a weighted least-squares problem. [Default: Ordinary least-squares fit]. Append +s to instead read data uncertainties (one sigma) and create weights as 1/sigma^2. If the robust option has been selected, the weights used in the robust fit will be written to weight.nc.

-^ or just -

  Print a short message about the syntax of the command, then exit (Note: on Windows just use -).

-+ or just +

  Print an extensive usage (help) message, including the explanation of any module-specific option (but not the GMT common options), then exit.

-? or no arguments

  Print a complete usage (help) message, including the explanation of all options, then exit.

--PAR=value

  Temporarily override a GMT default setting; repeatable. See gmt.conf for parameters.

## Remarks

The domain of x and y will be shifted and scaled to [-1, 1] and the basis functions are built from Legendre polynomials. These have a numerical advantage in the form of the matrix which must be inverted and allow more accurate solutions. NOTE: The model parameters listed with -V are Legendre polynomial coefficients; they are not numerically equivalent to the \(m_j\) in the equation described above. The description above is to allow the user to match -N with the order of the polynomial surface. See grdmath if you need to evaluate the trend using the reported coefficients.

## Examples

Note: Below are some examples of valid syntax for this module. The examples that use remote files (file names starting with `@`) can be cut and pasted into your terminal for testing. Other commands requiring input files are just dummy examples of the types of uses that are common but cannot be run verbatim as written.

To remove a planar trend from the remote grid earth_relief_05m for the region around Hawaii and write the result to hawaii_residual.nc:

    gmt grdtrend @earth_relief_05m -R180/240/10/40 -N3 -Dhawaii_residual.nc

To do a robust fit of a bicubic surface to hawaii_topo.nc, writing the result in hawaii_trend.nc and the weights used in hawaii_weight.nc, and reporting the progress:

    gmt grdtrend hawaii_topo.nc -N10+r -Thawaii_trend.nc -Whawaii_weight.nc -V

## See Also

gmt, grdfft, grdfilter, grdmath